<template>
    <BasicModal v-bind="$attrs" @register="registerModal" :title="title" @ok="handleSubmit" width="50%">
        <BasicForm @register="registerForm">
        </BasicForm>
    </BasicModal>
</template>

<script lang="ts" setup>
import { ref, computed, unref } from 'vue';

import { BasicModal, useModalInner } from '/@/components/Modal';
import { BasicForm, useForm } from '/@/components/Form/index';
import { BackFormSchema } from '../data';
import { back } from '../api';

// Emits声明
const emit = defineEmits(['register', 'success']);

const isUpdate = ref(true);
//表单配置
const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
    labelWidth: 220,
    schemas: BackFormSchema,
    // autoAdvancedCol: 2,
    // baseColProps: { span: 12 },
    showActionButtonGroup: false,
});
//表单赋值
const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
    //重置表单
    await resetFields();
    setModalProps({ confirmLoading: false, showCancelBtn: data?.showFooter, showOkBtn: data?.showFooter });
    //表单赋值
    await setFieldsValue({
        ...data.record,
    });

});
//设置标题
const title = ref('下达意见退回意见')
//表单提交事件
async function handleSubmit(v) {
    try {
        let values = await validate();
        setModalProps({ confirmLoading: true });
        //提交表单
        await back(values);
        //关闭弹窗
        closeModal();
        //刷新列表
        emit('success', { isUpdate: isUpdate.value, values });
    } finally {
        setModalProps({ confirmLoading: false });
    }
}

</script>

<style lang="less" scoped></style>